/**
 *
 * @author
 *
 */
var Game = (function (_super) {
    __extends(Game, _super);
    function Game() {
        _super.call(this);
        //private _vector:egret.Point;
        this._handlelocked = true;
        this.ball_tail = [];
        this._scaleoffset = 0;
        this.skinName = "resource/skins/GameSkin.exml";
        this.addBehaviour(new egs.scripts.UpdateListenerScript(this.onupdate, this));
        this.script_tail = new egs.scripts.TimerListenerScript(this.onupdate_tail, this, 25 / DataManager.getInstance().BallSpeed);
        this.addBehaviour(this.script_tail);
        //this._ball.x = Game.getInstance()._stageWidth/2 + 28;
        //this._ball_x = this._ball.x ;
        //this._ball_y = this._ball.y ;
        this.lb_top_level.text = DataManager.getInstance().Milestone.toString();
        //this.addEventListener(egret.TouchEvent.TOUCH_BEGIN,this.onTouch_Begin,this);
        this.addEventListener(egret.TouchEvent.TOUCH_MOVE, this.onTouch_Move, this);
        this.addEventListener(egret.TouchEvent.TOUCH_END, this.onTouch_End, this);
        //this.addEventListener(egret.TouchEvent.TOUCH_TAP,this.onTouch_Tap,this);
        this.addEventListener(egret.TouchEvent.TOUCH_CANCEL, this.onTouch_Cancel, this);
        this.addEventListener(egret.TouchEvent.TOUCH_RELEASE_OUTSIDE, this.onTouch_Outside, this);
        this.ExplodeFrames = [];
        this.ExplodeFrames[1] = RES.getRes("game_xiaobao_1_png");
        this.ExplodeFrames[2] = RES.getRes("game_xiaobao_2_png");
        this.ExplodeFrames[3] = RES.getRes("game_xiaobao_3_png");
        this.ExplodeFrames[4] = RES.getRes("game_xiaobao_4_png");
        this.ExplodeFrames[5] = RES.getRes("game_xiaobao_5_png");
        this.ringtextrue = RES.getRes("game_guangquan_png");
    }
    var d = __define,c=Game,p=c.prototype;
    Game.getInstance = function () {
        if (Game.instance == null) {
            Game.instance = new Game();
        }
        return Game.instance;
    };
    p.initPos = function () {
        this._ball.x = Game.getInstance()._stageWidth / 2;
        this._ball.y = Game.getInstance()._stageHeight / 2;
        this._ball_x = this._ball.x;
        this._ball_y = this._ball.y;
        this.gp_bao.width = this._stageWidth;
        this.gp_bao.height = this._stageHeight;
    };
    p.onTouch_Move = function (e) {
        if (!this.gp_line.visible) {
            return;
        }
        if (!this.img_hand.visible) {
            return;
        }
        this._handlelocked = false;
        var pt = new egret.Point(this._ball.x - e.stageX, this._ball.y - e.stageY);
        pt.normalize(1);
        this.drawAimLine(pt);
        this.img_hand.rotation = Math.atan2(e.stageY - this._ball.y, e.stageX - this._ball.x) * 180 / Math.PI - 90;
        //console.log(this._vector.toString());
    };
    p.drawAimLine2 = function (pt) {
        this.gp_line.removeChildren();
        var ox = this._ball.x;
        var oy = this._ball.y;
        var line = DataManager.getInstance().getLine();
        while (true) {
            ox += 25 * pt.x;
            oy += 25 * pt.y;
            var b = this.checkInRange(ox, oy, this._ball.radius);
            if (b == 1 || b == 3) {
                line -= 1;
                ox -= 25 * pt.x;
                pt.x = -pt.x;
            }
            if (b == 2 || b == 4) {
                line -= 1;
                oy -= 25 * pt.y;
                pt.y = -pt.y;
            }
            if (line <= 0) {
                break;
            }
            var shape = new egret.Shape(); // new eui.Rect(10,10);
            shape.graphics.beginFill(0xffffff);
            shape.graphics.drawCircle(-2.5, -2.5, 10 / 2);
            shape.graphics.endFill();
            shape.x = ox;
            shape.y = oy;
            this.gp_line.addChild(shape);
        }
    };
    p.drawAimLine = function (pt) {
        this.gp_line.removeChildren();
        var ox = this._ball.x;
        var oy = this._ball.y;
        var line = DataManager.getInstance().getLine();
        while (true) {
            ox += 25 * pt.x;
            oy += 25 * pt.y;
            var b = this.checkInRange(ox, oy, this._ball.radius);
            if (b == 1 || b == 3) {
                line -= 1;
                ox -= 25 * pt.x;
                pt.x = -pt.x;
            }
            if (b == 2 || b == 4) {
                line -= 1;
                oy -= 25 * pt.y;
                pt.y = -pt.y;
            }
            if (line <= 0) {
                break;
            }
            var rect = new eui.Rect(10, 10);
            rect.fillColor = 0xffffff;
            rect.fillAlpha = 0.4;
            rect.ellipseWidth = rect.ellipseHeight = 10;
            rect.x = ox;
            rect.y = oy;
            this.gp_line.addChild(rect);
        }
    };
    p.onTouch_End = function (e) {
        //this.createJewel(20,9);
        if (this._handlelocked) {
            return;
        }
        if (!this.img_hand.visible) {
            return;
        }
        this.handleLaunch(e);
    };
    p.onTouch_Cancel = function (e) {
        if (this._handlelocked) {
            return;
        }
        this.handleLaunch(e);
    };
    p.onTouch_Outside = function (e) {
        if (this._handlelocked) {
            return;
        }
        this.handleLaunch(e);
    };
    p.handleLaunch = function (e) {
        if (!this.gp_line.visible) {
            return;
        }
        if (this.gp_begin.alpha < 1) {
            return;
        }
        this._handlelocked = true;
        this._ball.setMoveVector(new egret.Point(this._ball.x - e.stageX, this._ball.y - e.stageY));
        this.gp_line.visible = false;
        //this.img_hand.visible = false;
        this.img_hand.source = RES.getRes("hand_2_png");
        egret.Tween.get(this.img_hand)
            .wait(500)
            .to({ "alpha": 0 }, 1000)
            .set({ "alpha": 1, "visible": false, "source": RES.getRes("hand_1_png") });
    };
    p.onupdate = function (dt) {
        if (!this._ball.visible) {
            return;
        }
        var jewel = null;
        for (var j = this.gp_move.numChildren - 1; j >= 0; j--) {
            var ball = this.gp_move.getChildAt(j);
            ball.onUpdate(dt);
            for (var i = 0; i < this.gp_table.numChildren; i++) {
                jewel = this.gp_table.getChildAt(i);
                if (Ball.collision(jewel, ball)) {
                    if (jewel instanceof Jewel2) {
                        Sound.getInstance().Play_Jia5();
                        ball.rebound += 5;
                        DataManager.getInstance().BallSpeed *= 1.5;
                        this.gp_table.removeChild(jewel);
                    }
                    else if (jewel instanceof Jewel3) {
                        Sound.getInstance().Play_Fenlei();
                        var sum = jewel.I % 100 + 2;
                        var a = 360 / sum;
                        var x = Math.random() * 2 - 1;
                        var y = Math.random() * 2 - 1;
                        for (var i = 0; i < sum; i++) {
                            var sub = new MoveBall();
                            sub.skinName = this._ball.skinName;
                            sub.x = jewel.x;
                            sub.y = jewel.y;
                            //sub.moveSpeed = DataManager.getInstance().BallSpeed;
                            var angleHude = (-a * i) * Math.PI / 180;
                            var px = Math.cos(angleHude) * x + y * Math.sin(angleHude);
                            var py = Math.sin(angleHude) * -x + y * Math.cos(angleHude);
                            sub.setMoveVector(new egret.Point(px, py));
                            sub.rebound = -1;
                            this.gp_move.addChild(sub);
                        }
                        this.gp_table.removeChild(jewel);
                    }
                    else {
                        //jewel.alpha = 0.3;
                        this.showExplode(jewel);
                    }
                    if (this.gp_table.numChildren <= 0) {
                        this.gameOver(true);
                    }
                    break;
                }
            }
        }
        this.script_tail._span = (25 / DataManager.getInstance().BallSpeed);
        if (this.img_light.visible) {
            this.img_light.rotation += dt * 20;
        }
        for (var i = 0; i < this.ball_tail.length; i++) {
            if (this._scaleoffset >= 0) {
                if (this._ball_x == this.ball_tail[i].x && this._ball_y == this.ball_tail[i].y) {
                    this.removeSelfMiniBall(this.ball_tail[i]);
                    this.ball_tail.splice(i, 1);
                    break;
                }
            }
        }
    };
    p.onupdate_tail = function () {
        if (this.ball_tail.length > 0) {
            for (var i = this.ball_tail.length - 1; i >= 1; i--) {
                var item1 = this.ball_tail[i - 1];
                var item2 = this.ball_tail[i];
                item2.x = item1.x;
                item2.y = item1.y;
            }
            var head = this.ball_tail[0];
            head.x = this._ball.lastPosX;
            head.y = this._ball.lastPosY;
        }
        this._ball.lastPosX = this._ball.x;
        this._ball.lastPosY = this._ball.y;
    };
    p.checkInRange = function (x, y, radius, obj) {
        if (radius === void 0) { radius = 0; }
        if (obj === void 0) { obj = null; }
        //var rt = new egret.Rectangle(0,0,this.stage.stageWidth,this.stage.stageHeight);
        //return rt.containsPoint(new egret.Point(x,y));
        if (x <= radius)
            return 1;
        if (y <= radius)
            return 2;
        if (x >= this._stageWidth - radius)
            return 3;
        if (y >= this._stageHeight - radius)
            return 4;
        /*
        if(obj == null){
            if(x >= this.stage.stageWidth - radius) return 3;
            if(y >= this.stage.stageHeight - radius) return 4;
        }
        else{
            if(x >= obj.stage.stageWidth - radius) return 3;
            if(y >= obj.stage.stageHeight - radius) return 4;
        }*/
        return -1;
    };
    p.createJewel = function (count, line, special) {
        //var vx = Math.random() * 2 - 1;
        //var vy = Math.random() * 2 - 1;
        var a = (180 + 45) + Math.random() * (120) + 60; //Math.random() * (180 - 40) + 20 + 45;
        if (Math.random() < 0.5) {
            a = 180 - a;
        }
        console.log(a);
        var angleHude = (-a) * Math.PI / 180;
        var vx = Math.cos(angleHude) * 0.5 + 0.5 * Math.sin(angleHude);
        var vy = Math.sin(angleHude) * -0.5 + 0.5 * Math.cos(angleHude);
        var ox = this._ball_x + vx * 200;
        var oy = this._ball_y + vy * 200;
        var op = new egret.Point(this._ball_x, this._ball_y);
        var pts = [];
        for (var i = 0; i < line; i++) {
            while (true) {
                ox += 50 * vx;
                oy += 50 * vy;
                var b = this.checkInRange(ox, oy, 70);
                if (b == 1 || b == 3) {
                    vx = -vx;
                    break;
                }
                else if (b == 2 || b == 4) {
                    vy = -vy;
                    break;
                }
                var pt = new egret.Point(ox, oy);
                if (egret.Point.distance(pt, op) <= 150) {
                    continue;
                }
                pts.push(pt);
            }
        }
        var jewel = null;
        for (var i = 0; i < count; i++) {
            if (pts.length <= 0) {
                break;
            }
            var j = Math.floor(Math.random() * pts.length);
            var pt = pts[j];
            pts.splice(j, 1);
            if (jewel == null) {
                jewel = new Jewel(i % 5 + 1);
                //jewel = new Jewel(Math.floor(Math.random() * 5) + 1);
                jewel.updateBlock();
            }
            jewel.x = pt.x;
            jewel.y = pt.y;
            if (this.checkJewelCollision(jewel)) {
                i -= 1;
                continue;
            }
            this.gp_table.addChild(jewel);
            jewel = null;
        }
        var ex = special;
        jewel = null;
        while (ex > 0 && pts.length > 0) {
            var j = Math.floor(Math.random() * pts.length);
            var pt = pts[j];
            pts.splice(j, 1);
            if (jewel == null) {
                if (Math.random() > 0.5) {
                    var type = Math.floor(Math.random() * 4 + 1);
                    jewel = new Jewel3(100 + type);
                }
                else {
                    jewel = new Jewel2();
                }
                jewel.updateBlock();
            }
            jewel.x = pt.x;
            jewel.y = pt.y;
            if (this.checkJewelCollision(jewel)) {
                continue;
            }
            this.gp_table.addChild(jewel);
            ex -= 1;
        }
    };
    p.checkJewelCollision = function (jewel) {
        var pt = new egret.Point(jewel.x, jewel.y);
        var pt2 = new egret.Point(this.img_hand.x, this.img_hand.y);
        if (egret.Point.distance(pt, pt2) <= jewel.radius + this.img_hand.anchorOffsetX) {
            return true;
        }
        for (var i = 0; i < this.gp_table.numChildren; i++) {
            var jewel2 = this.gp_table.getChildAt(i);
            if (Jewel.collision(jewel, jewel2)) {
                return true;
            }
        }
        return false;
    };
    //开始游戏
    p.beginGame = function () {
        //egret.Tween.removeAllTweens();
        this.gp_bao.visible = false;
        //this._ball.visible = this.img_hand.visible = this.gp_line.visible = false;
        this.bg_bg.NextBG();
        this.lb_mid_level.text = DataManager.getInstance().Milestone.toString();
        this.gp_level_show.visible = true;
        this.gp_level_show.alpha = 0;
        this.gp_table_bottom.removeChildren();
        egret.Tween.get(this.gp_level_show)
            .to({ "alpha": 1 }, 500)
            .wait(1000)
            .to({ "alpha": 0 }, 750)
            .set({ "visible": false })
            .call(this.initLevel, this);
        this.gp_begin.alpha = 0;
        this.gp_begin.visible = false;
        this.gp_table.alpha = 0;
        //this.gp_table.visible = false;
        this.img_yuan.visible = true;
        //this.initLevel();
        //DataManager.getInstance().PlaySum += 1;
        this._scaleoffset = -1;
    };
    p.initLevel = function () {
        this.lb_top_level.text = DataManager.getInstance().Milestone.toString();
        egret.Tween.get(this.gp_begin)
            .set({ "visible": true })
            .to({ "alpha": 1 }, 1000);
        egret.Tween.get(this.gp_table)
            .to({ "alpha": 1 }, 1000);
        this.img_light.visible = false;
        this.img_box.visible = false;
        DataManager.getInstance().BallSpeed = DataManager.getInstance().defBallSpeed;
        this._ball.resetBall(DataManager.getInstance().CurrentBall + 1);
        this._ball.visible = true;
        this._ball.x = this._ball_x; //this._ball_x + this._ball.radius;
        this._ball.y = this._ball_y; //this._ball_y + this._ball.radius;
        this.img_hand.visible = this.gp_line.visible = true;
        this.img_hand.rotation = 0;
        this.gp_table.removeChildren();
        this.gp_table_bottom.removeChildren();
        this.gp_line.removeChildren();
        this.ball_tail = [];
        this.script_tail._span = 25 / DataManager.getInstance().BallSpeed;
        DataManager.getInstance().CostPlay = DataManager.getInstance().Milestone * 2;
        //this.createJewel(3,2,1);
        //return;
        var leveldata = DataManager.getInstance().getLevelDataFromMilestone();
        if (leveldata != null) {
            if (leveldata.Points != null) {
                for (var i = 0; i < leveldata.Points.length; i++) {
                    var item = leveldata.Points[i];
                    var jewel;
                    if (item.I < 100) {
                        jewel = new Jewel(item.I);
                    }
                    else if (item.I == 200) {
                        jewel = new Jewel2();
                    }
                    else {
                        jewel = new Jewel3(item.I);
                    }
                    jewel.x = item.X;
                    jewel.y = item.Y;
                    jewel.updateBlock();
                    this.gp_table.addChild(jewel);
                }
            }
            else {
                this.createJewel(leveldata.count, leveldata.line, leveldata.special);
                leveldata.Points = [];
                for (var i = 0; i < this.gp_table.numChildren; i++) {
                    var jewel = this.gp_table.getChildAt(i);
                    var item = new JewelPos();
                    item.X = jewel.x;
                    item.Y = jewel.y;
                    item.I = jewel.I;
                    leveldata.Points.push(item);
                }
                DataManager.getInstance().saveLevelDataToMilestone(leveldata);
            }
        }
        else {
        }
        for (var i = 0; i < this.gp_table.numChildren; i++) {
            var obj = this.gp_table.getChildAt(i);
            var x = obj.x;
            var y = obj.y;
            obj.x = this._ball_x;
            obj.y = this._ball_y;
            obj.alpha = 0;
            egret.Tween.get(obj)
                .wait(1000 + (1000 / 8) * i)
                .call(Sound.getInstance().Play_Button, Sound.getInstance())
                .to({ "alpha": 1, "x": x, "y": y }, 1000 / 8, egret.Ease.quartOut);
        }
        this.img_hand.visible = false;
        this._ball.visible = false;
        egret.Tween.get(this).wait(1000 + (1000 / 8) * i).call(this.showHand, this);
    };
    p.showHand = function () {
        this.img_yuan.visible = false;
        this.img_hand.visible = true;
        this._ball.visible = true;
    };
    //爆炸宝石
    p.showExplode = function (jewel) {
        this.gp_table.removeChild(jewel);
        Sound.getInstance().Play_Papa();
        for (var i = 0; i < 10; i++) {
            var x = Math.random() * 400 + jewel.radius / 2 - 200;
            var y = Math.random() * 400 + jewel.radius / 2 - 200;
            var sub = new eui.Image(this.ExplodeFrames[jewel.I]);
            sub.x = jewel.x;
            sub.y = jewel.y;
            sub.anchorOffsetX = sub.anchorOffsetY = 50 / 2;
            if (this.gp_table.numChildren > 0) {
                egret.Tween.get(sub)
                    .to({ "x": sub.x + x, "y": sub.y + y }, 500, egret.Ease.quartOut)
                    .call(this.callBallTail, this, [sub]);
            }
            else {
                sub.x = sub.x + x;
                sub.y = sub.y + y;
                this.callBallTail(sub);
            }
            this.gp_table_bottom.addChild(sub);
        }
        var ring = new eui.Image(this.ringtextrue);
        this.addChild(ring);
        ring.anchorOffsetX = ring.anchorOffsetY = 83 / 2;
        ring.x = jewel.x;
        ring.y = jewel.y;
        ring.alpha = 0;
        ring.rotation = 0;
        ring.scaleX = ring.scaleY = 0.2;
        /*
        egret.Tween.get(ring)
            .to({ "scaleX": 1,"scaleY": 1,"alpha": 1,"rotation":180},300)
            .to({ "alpha": 0,"scaleX": 2,"scaleY": 2,"rotation": 360 },300,egret.Ease.quartOut)
            .call(this.removeEffect,this,[ring]);
        */
        egret.Tween.get(ring)
            .to({ "scaleX": 1, "scaleY": 1, "alpha": 1 }, 300)
            .to({ "alpha": 0, "scaleX": 3, "scaleY": 3 }, 300, egret.Ease.quartOut)
            .call(this.removeEffect, this, [ring]);
        return;
        var target = DataManager.getInstance().BallSpeed;
        DataManager.getInstance().BallSpeed = 0;
        egret.Tween.removeTweens(DataManager.getInstance());
        egret.Tween.get(DataManager.getInstance())
            .wait(100)
            .set({ "BallSpeed": target });
    };
    p.callBallTail = function (sub) {
        this.addtoBallTail(sub);
        /*
        egret.Tween.get(sub)
            .to({ "alpha": 0 },300,egret.Ease.quartOut)
            .call(this.addtoBallTail,this,[sub])
                //.wait(100 * this.ball_tail.l)
            .to({ "alpha": 1 },500,egret.Ease.quartOut);
            return;

          
        if(this.ball_tail.length > 0){
            egret.Tween.get(sub)
                .to({ "alpha": 0,"x": this.ball_tail[this.ball_tail.length - 1].x,"y": this.ball_tail[this.ball_tail.length - 1].y },200,egret.Ease.quartOut)
                .call(this.addtoBallTail,this,[sub]);
        }else{
            egret.Tween.get(sub)
                .to({ "x": this._ball.x,"y": this._ball.y,"alpha": 0},200,egret.Ease.quartOut)
                .call(this.addtoBallTail,this,[sub]);
        }
        */
    };
    p.addtoBallTail = function (sub) {
        sub.alpha = 1;
        egret.Tween.removeTweens(sub);
        this.ball_tail.push(sub);
    };
    p.gameOver = function (win) {
        if (win === void 0) { win = true; }
        if (Over.getInstance().visible == true) {
            return;
        }
        if (this.gp_table.numChildren <= 0) {
            win = true;
        }
        this.addChildAt(Over.getInstance(), this.numChildren - 1);
        if (win) {
            Sound.getInstance().Play_Perfect();
            for (var i = 0; i < this.gp_table_bottom.numChildren; i++) {
                var obj = this.gp_table_bottom.getChildAt(i);
                //egret.Tween.removeTweens(obj);
                obj.alpha = 1;
            }
            //this._ball.visible = false;
            this.gp_bao.visible = true;
            this.img_perfect.visible = true;
            this.img_perfect.alpha = 0;
            this.img_perfect.scaleX = this.img_perfect.scaleY = 0.7;
            var wait = this.ball_tail.length * this.script_tail._span * 1000;
            egret.Tween.get(this.img_perfect)
                .to({ "alpha": 1, "scaleX": 1, "scaleY": 1 }, 500, egret.Ease.backOut)
                .wait(500 + wait / 2)
                .set({ "visible": false })
                .call(this.showBoxAnimat, this);
            this._ball.rebound = 99;
        }
        else {
            Over.getInstance().handleOver();
        }
    };
    p.removeEffect = function (obj) {
        egret.Tween.removeTweens(obj);
        if (obj.parent != null) {
            obj.parent.removeChild(obj);
        }
    };
    p.showBoxAnimat = function () {
        for (var i = this.gp_move.numChildren - 1; i >= 1; i--) {
            var ball = this.gp_move.getChildAt(i);
            egret.Tween.removeTweens(ball);
            this.gp_move.removeChild(ball);
        }
        this.img_light.visible = true;
        this.img_box.visible = true;
        this.img_box.scaleX = this.img_box.scaleY = 0.5;
        DataManager.getInstance().Milestone += 1;
        var len = this.script_tail._span * this.ball_tail.length * 1000;
        var p1 = new egret.Point(this._ball.x, this._ball.y);
        var p2 = new egret.Point(this._ball_x, this._ball_y);
        var d = egret.Point.distance(p1, p2);
        var wait = (d / this._ball.moveSpeed) * 1000;
        this._ball.setMoveVector(null);
        egret.Tween.get(this._ball)
            .to({ "x": this._ball_x, "y": this._ball_y }, wait);
        //.set({"visible":false});
        egret.Tween.get(this.img_box)
            .wait(wait)
            .call(Sound.getInstance().Play_gold, Sound.getInstance());
        //.wait(len + 1000 + 1000)
        //.call(this.beginGame,this);
        this._scaleoffset = 0.5 / this.ball_tail.length;
        /*
        var span = this.script_tail._span * 1500 ;
        for(var i = 0;i < this.ball_tail.length;i++) {
            var obj = this.ball_tail[(i)];
            egret.Tween.get(obj).wait(span * (i + 1) + wait  )
                .call(this.removeSelfMiniBall,this,[obj]);
        }
        */
        this.show_quangguan();
        this.timer = new egret.Timer(150);
         this.timer.addEventListener(egret.TimerEvent.TIMER,this.show_quangguan,this);
         this.timer.start();
    };
    p.show_quangguan = function (){
    	var ring = new eui.Image(this.ringtextrue);
        this.addChild(ring);
        ring.anchorOffsetX = ring.anchorOffsetY = 83 / 2;
        ring.x = this._stageWidth / 2;
        ring.y = this._stageHeight / 2;
        //ring.x = 100;
        //ring.y = 100;
        ring.alpha = 1;
        ring.rotation = 0;
        ring.scaleX = ring.scaleY = 0.2;
        
        egret.Tween.get(ring)
            .to({ "scaleX": 3, "scaleY": 3, "alpha": 0 }, 500);
    };
    p.removeSelfMiniBall = function (obj) {
        //Sound.getInstance().Play_GoldLoop();
        this.img_box.scaleX += this._scaleoffset;
        this.img_box.scaleY += this._scaleoffset;
        //egret.Tween.get(this.img_box).to({ "scaleX": this.img_box.scaleX += offset,"scaleY": this.img_box.scaleY += offset },span,egret.Ease.backIn);
        egret.Tween.removeTweens(obj);
        if (obj.parent != null) {
            obj.parent.removeChild(obj);
        }
        if (this.gp_table_bottom.numChildren <= 0) {
            egret.Tween.get(this.img_box) //.wait(span)
                .call(Sound.getInstance().Play_GoldOver, Sound.getInstance())
                .to({ "scaleX": 1.2, "scaleY": 1.2 }, 200, egret.Ease.backInOut)
                .wait(1000)
                .call(this.beginGame, this);
            Sound.getInstance().Stop_gold();
            this.ball_tail = [];
        }
        DataManager.getInstance().Gold += DataManager.getInstance().subGold;
    };
    Game.instance = null;
    return Game;
}(eui.Component));
egret.registerClass(Game,'Game');
