/**
 *
 * @author
 *
 */
var Begin = (function (_super) {
    __extends(Begin, _super);
    function Begin() {
        _super.call(this);
        this.skinName = "resource/skins/BeginSkin.exml";
        this.btn_shop.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onclick_shop, this);
        this.btn_go.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onclick_go, this);
        //this.btn_rank.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onclick_rank, this);
        this.gp_sound.getChildAt(0).addEventListener(egret.TouchEvent.TOUCH_TAP, this.onclick_sound_off, this);
        this.gp_sound.getChildAt(1).addEventListener(egret.TouchEvent.TOUCH_TAP, this.onclick_sound_on, this);
        //this.showAnimat();
        this.img_loading.visible = true;
        this.img_loading.alpha = 0;
        this.gp_begin.visible = false;
        if (Sound.getInstance().IsMute) {
            this.onclick_sound_off();
        }
        else {
            this.onclick_sound_on();
        }
        egret.Tween.get(this.img_loading).to({ "alpha": 1 }, 500)
            .wait(500)
            .to({ "alpha": 0 }, 1000)
            .call(this.showAnimat, this);
        this.lb_v.text = DataManager.getInstance().ver;
        // TypeScript 代码
        var selfthat = this;
        egret.ExternalInterface.addCallback("showAd2Complete", function (message) {
            selfthat.onstartgame_go();
        });
    }
    var d = __define,c=Begin,p=c.prototype;
    Begin.getInstance = function () {
        if (Begin.instance == null) {
            Begin.instance = new Begin();
        }
        return Begin.instance;
    };
    p.updateStageHeight = function () {
        //console.log(this.stage.stageWidth + "," + this.stage.stageHeight);
        this.gp_buttons.y = this.stage.stageHeight - 240;
        this.img_loading.y = (this.stage.stageHeight - this.img_loading.height) / 2;
    };
    p.showAnimat = function () {
        this.gp_begin.visible = true;
        this.gp_begin.alpha = 0;
        egret.Tween.get(this.gp_begin).to({ "alpha": 1 }, 1000);
        egret.Tween.removeTweens(this.btn_go);
        this.img_logo.anchorOffsetY = 400;
        egret.Tween.get(this.img_logo).to({ "anchorOffsetY": 0 }, 500, egret.Ease.backOut);
        for (var i = 0; i < this.gp_buttons.numChildren; i++) {
            var item = this.gp_buttons.getChildAt(i);
            item.anchorOffsetY = -500;
            item.alpha = 0;
            egret.Tween.get(item)
                .to({ "alpha": 1, "anchorOffsetY": 0 }, 500, egret.Ease.cubicOut);
        }
        egret.Tween.get(this.btn_go, { "loop": true })
            .wait(1000)
            .to({ "anchorOffsetY": 30 }, 1000)
            .to({ "anchorOffsetY": 0 }, 1000);
    };
    p.onclick_shop = function () {
        Shop.getInstance().Show(this);
    };
    p.onclick_go = function () {
        Sound.getInstance().Play_Button();
        //点击开始，判断金钱够不够
        if (DataManager.getInstance().Milestone >= 2) {
            if (DataManager.getInstance().Gold - DataManager.getInstance().Milestone < 0) {
                Dialog.getInstance().ShowNeedMore(this.parent, "2");
                return;
            }
            else {
                DataManager.getInstance().Gold -= DataManager.getInstance().Milestone;
            }
        }
        this.onstartgame_go();
    };
    p.onstartgame_go = function () {
        this.parent.addChild(Game.getInstance());
        this.parent.removeChild(this);
        Game.getInstance().beginGame();
    };
    p.onclick_rank = function () {
        Sound.getInstance().Play_Button();
        alert("点击了排行榜，代码在：Begin.ts");
        //egret.localStorage.clear();
    };
    p.onclick_sound_off = function () {
        Sound.getInstance().Play_Button();
        this.gp_sound.getChildAt(0).visible = false;
        this.gp_sound.getChildAt(1).visible = true;
        Sound.getInstance().IsMute = true;
    };
    p.onclick_sound_on = function () {
        Sound.getInstance().Play_Button();
        this.gp_sound.getChildAt(1).visible = false;
        this.gp_sound.getChildAt(0).visible = true;
        Sound.getInstance().IsMute = false;
    };
    Begin.instance = null;
    return Begin;
}(eui.Component));
egret.registerClass(Begin,'Begin');
