var egs;
(function (egs) {
    var scripts;
    (function (scripts) {
        var TimerListenerScript = (function (_super) {
            __extends(TimerListenerScript, _super);
            function TimerListenerScript(timercallback, thisobj, span) {
                _super.call(this);
                this._span = 0;
                this._sum = 0;
                this._count = 0;
                this._mark = 0;
                this._span = span;
                this.onUpdateCall = timercallback;
                this.callThisObj = thisobj;
            }
            var d = __define,c=TimerListenerScript,p=c.prototype;
            p.onUpdate = function (dt) {
                this._sum += dt;
                this._mark += dt;
                if (this._mark >= this._span) {
                    this._mark = 0;
                    this._count += 1;
                    if (this.onUpdateCall != null) {
                        this.onUpdateCall.call(this.callThisObj, this._sum, this._count);
                    }
                }
            };
            p.Reset = function () {
                this._sum = 0;
                this._mark = 0;
            };
            return TimerListenerScript;
        }(egs.Behaviour));
        scripts.TimerListenerScript = TimerListenerScript;
        egret.registerClass(TimerListenerScript,'egs.scripts.TimerListenerScript');
    })(scripts = egs.scripts || (egs.scripts = {}));
})(egs || (egs = {}));
