var egs;
(function (egs) {
    var scripts;
    (function (scripts) {
        var TouchScript = (function (_super) {
            __extends(TouchScript, _super);
            function TouchScript() {
                _super.call(this);
            }
            var d = __define,c=TouchScript,p=c.prototype;
            p.onStart = function () {
                var obj = this.Owner;
                if (obj != null) {
                    obj.addEventListener(egret.TouchEvent.TOUCH_BEGIN, this.onTouch_Begin, this);
                    obj.addEventListener(egret.TouchEvent.TOUCH_MOVE, this.onTouch_Move, this);
                    obj.addEventListener(egret.TouchEvent.TOUCH_END, this.onTouch_End, this);
                    obj.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onTouch_Tap, this);
                    obj.addEventListener(egret.TouchEvent.TOUCH_CANCEL, this.onTouch_Cancel, this);
                    obj.addEventListener(egret.TouchEvent.TOUCH_RELEASE_OUTSIDE, this.onTouch_Outside, this);
                }
            };
            p.onRemove = function () {
                var obj = this.Owner;
                if (obj != null) {
                    obj.removeEventListener(egret.TouchEvent.TOUCH_BEGIN, this.onTouch_Begin, this);
                    obj.removeEventListener(egret.TouchEvent.TOUCH_MOVE, this.onTouch_Move, this);
                    obj.removeEventListener(egret.TouchEvent.TOUCH_END, this.onTouch_End, this);
                    obj.removeEventListener(egret.TouchEvent.TOUCH_TAP, this.onTouch_Tap, this);
                    obj.removeEventListener(egret.TouchEvent.TOUCH_CANCEL, this.onTouch_Cancel, this);
                    obj.removeEventListener(egret.TouchEvent.TOUCH_RELEASE_OUTSIDE, this.onTouch_Outside, this);
                }
            };
            p.onTouch_Begin = function (e) {
            };
            p.onTouch_Move = function (e) {
            };
            p.onTouch_End = function (e) {
            };
            p.onTouch_Tap = function (e) {
            };
            p.onTouch_Cancel = function (e) {
            };
            p.onTouch_Outside = function (e) {
            };
            return TouchScript;
        }(egs.Behaviour));
        scripts.TouchScript = TouchScript;
        egret.registerClass(TouchScript,'egs.scripts.TouchScript');
    })(scripts = egs.scripts || (egs.scripts = {}));
})(egs || (egs = {}));
